Index: platform/a570/sub/100e/capt_seq.c
===================================================================
--- platform/a570/sub/100e/capt_seq.c	(Revision 727)
+++ platform/a570/sub/100e/capt_seq.c	(Arbeitskopie)
@@ -302,3 +302,527 @@
 	);
 }
 
+/*************************************************************/
+void __attribute__((naked,noinline)) _task_ExpDrvTask(){
+ asm volatile(
+                 "STMFD   SP!, {R4-R8,LR}\n"
+                 "SUB     SP, SP, #0x20\n"
+                 "ADD     R7, SP, #4\n"
+                 "B       loc_ffd246dc\n"
+ "loc_ffd241dc:\n"
+                 "CMP     R2, #0x22\n"
+                 "BNE     loc_ffd241f4\n"
+                 "LDR     R0, [R12,#0x8C]\n"
+                 "MOV     LR, PC\n"
+                 "LDR     PC, [R12,#0x88]\n"
+                 "B       loc_ffd24258\n"
+ "loc_ffd241f4:\n"
+                 "CMP     R2, #0x1D\n"
+                 "BNE     loc_ffd24208\n"
+                 "MOV     R0, R12\n"
+                 "BL      sub_ffd2409c\n"
+                 "B       loc_ffd24248\n" 
+ "loc_ffd24208:\n"
+                 "CMP     R2, #0x1E\n"
+                 "BNE     loc_ffd2421c\n"
+                 "MOV     R0, R12\n"
+                 "BL      sub_ffd240f8\n"
+                 "B       loc_ffd24248\n"
+ "loc_ffd2421c:\n"
+                 "SUB     R3, R2, #0x1F\n"
+                 "CMP     R3, #1\n"
+                 "BHI     loc_ffd24234\n"
+                 "MOV     R0, R12\n"
+                 "BL      sub_ffd24154\n"
+                 "B       loc_ffd24248\n"
+ "loc_ffd24234:\n"
+                 "CMP     R2, #0x21\n"
+                 "BNE     loc_ffd24264\n"
+                 "BL      sub_ffcea234\n"
+                 "BL      sub_ffced36c\n"
+                 "BL      sub_ffcec5a4\n"
+ "loc_ffd24248:\n"
+                 "LDR     R3, [SP,#4]\n"
+                 "LDR     R0, [R3,#0x8C]\n"
+                 "MOV     LR, PC\n"
+                 "LDR     PC, [R3,#0x88]\n"
+ "loc_ffd24258:\n"
+                 "LDR     R0, [SP,#4]\n"
+                 "BL      sub_ffd1f8d4\n"
+                 "B       loc_ffd246dc\n"
+ "loc_ffd24264:\n"
+                 "CMP     R2, #0xD\n"
+                 "MOV     R8, #1\n"
+                 "BNE     loc_ffd242d4\n"
+                 "LDR     R1, [R12,#0x7C]\n"
+                 "ADD     R1, R1, R1,LSL#1\n"
+                 "ADD     R1, R12, R1,LSL#2\n"
+                 "ADD     R6, SP, #0x14\n"
+                 "SUB     R1, R1, #8\n"
+                 "MOV     R2, #0xC\n"
+                 "MOV     R0, R6\n"
+                 "BL      _memcpy\n"
+                 "LDR     R0, [SP,#4]\n"
+                 "BL      sub_ffd224ac\n"
+                 "LDR     R3, [SP,#4]\n"
+                 "LDR     R1, [R3,#0x7C]\n"
+                 "LDR     R2, [R3,#0x8C]\n"
+                 "ADD     R0, R3, #4\n"
+                 "MOV     LR, PC\n"
+                 "LDR     PC, [R3,#0x88]\n"
+                 "LDR     R0, [SP,#4]\n"
+                 "BL      sub_ffd22778\n"
+                 "LDR     R3, [SP,#4]\n"
+                 "ADD     R0, R3, #4\n"
+                 "LDR     R1, [R3,#0x7C]\n"
+                 "LDR     R2, [R3,#0x94]\n"
+                 "MOV     LR, PC\n"
+                 "LDR     PC, [R3,#0x90]\n"
+                 "B       loc_ffd24624\n"
+ "loc_ffd242d4:\n"
+                 "SUB     R3, R2, #0xE\n"
+                 "CMP     R3, #1\n"
+                 "BHI     loc_ffd24390\n"
+                 "ADD     R6, SP, #0x14\n"
+                 "ADD     R5, SP, #8\n"
+                 "MOV     R0, R12\n"
+                 "MOV     R1, R6\n"
+                 "MOV     R2, R5\n"
+                 "BL      sub_ffd22868\n"
+                 "MOV     R4, R0\n"
+                 "CMP     R4, #5\n"
+                 "CMPNE   R4, #1\n"
+                 "BNE     loc_ffd24328\n"
+                 "LDR     R12, [SP,#4]\n"
+                 "MOV     R0, R5\n"
+                 "LDR     R1, [R12,#0x7C]\n"
+                 "MOV     R2, R4\n"
+                 "LDR     R3, [R12,#0x8C]\n"
+                 "MOV     LR, PC\n"
+                 "LDR     PC, [R12,#0x88]\n"
+                 "B       loc_ffd24360\n"
+ "loc_ffd24328:\n"
+                 "CMP     R4, #6\n"
+                 "CMPNE   R4, #2\n"
+                 "BNE     loc_ffd24370\n"
+                 "LDR     R12, [SP,#4]\n"
+                 "MOV     R0, R5\n"
+                 "MOV     R1, R8\n"
+                 "MOV     R2, R4\n"
+                 "LDR     R3, [R12,#0x8C]\n"
+                 "MOV     LR, PC\n"
+                 "LDR     PC, [R12,#0x88]\n"
+                 "MOV     R1, R6\n"
+                 "LDR     R0, [SP,#4]\n"
+                 "MOV     R2, R5\n"
+                 "BL      sub_ffd23cfc\n"
+ "loc_ffd24360:\n"
+                 "MOV     R1, R4\n"
+                 "LDR     R0, [SP,#4]\n"
+                 "BL      sub_ffd24030\n"
+                 "B       loc_ffd24624\n"
+ "loc_ffd24370:\n"
+                 "LDR     R12, [SP,#4]\n"
+                 "MOV     R2, R4\n"
+                 "ADD     R0, R12, #4\n"
+                 "LDR     R1, [R12,#0x7C]\n"
+                 "LDR     R3, [R12,#0x8C]\n"
+                 "MOV     LR, PC\n"
+                 "LDR     PC, [R12,#0x88]\n"
+                 "B       loc_ffd24624\n"
+ "loc_ffd24390:\n"
+                 "SUB     R3, R2, #0x19\n"
+                 "CMP     R3, #1\n"
+                 "BHI     loc_ffd243e8\n"
+                 "LDR     R1, [R12,#0x7C]\n"
+                 "ADD     R1, R1, R1,LSL#1\n"
+                 "ADD     R1, R12, R1,LSL#2\n"
+                 "ADD     R6, SP, #0x14\n"
+                 "SUB     R1, R1, #8\n"
+                 "MOV     R2, #0xC\n"
+                 "MOV     R0, R6\n"
+                 "BL      _memcpy\n"
+                 "LDR     R0, [SP,#4]\n"
+                 "BL      sub_ffd218a0\n"
+                 "LDR     R3, [SP,#4]\n"
+                 "ADD     R0, R3, #4\n"
+                 "LDR     R1, [R3,#0x7C]\n"
+                 "LDR     R2, [R3,#0x8C]\n"
+                 "MOV     LR, PC\n"
+                 "LDR     PC, [R3,#0x88]\n"
+                 "LDR     R0, [SP,#4]\n"
+                 "BL      sub_ffd21c7c\n"
+                 "B       loc_ffd24624\n"
+ "loc_ffd243e8:\n"
+                 "ADD     R6, SP, #0x14\n"
+                 "ADD     R1, R12, #4\n"
+                 "MOV     R2, #0xC\n"
+                 "MOV     R0, R6\n"
+                 "BL      memcpy\n"
+                 "LDR     R12, [SP,#4]\n"
+                 "LDR     R3, [R12]\n"
+                 "MOV     R2, R12\n"
+                 "CMP     R3, #0x1C\n"
+                 "LDRLS   PC, [PC,R3,LSL#2]\n"
+                 "B       loc_ffd24610\n"
+                 ".long loc_ffd24488\n"
+                 ".long loc_ffd24494\n"
+                 ".long loc_ffd244a0\n"
+                 ".long loc_ffd244a0\n"
+                 ".long loc_ffd24488\n"
+                 ".long loc_ffd24494\n"
+                 ".long loc_ffd244a0\n"
+                 ".long loc_ffd244a0\n"
+                 ".long loc_ffd244c4\n"
+                 ".long loc_ffd244c4\n"
+                 ".long loc_ffd245e4\n"
+                 ".long loc_ffd245f0\n"
+                 ".long loc_ffd24600\n"
+                 ".long loc_ffd24610\n"
+                 ".long loc_ffd24610\n"
+                 ".long loc_ffd24610\n"
+                 ".long loc_ffd244ac\n"
+                 ".long loc_ffd244b8\n"
+                 ".long loc_ffd244d4\n"
+                 ".long loc_ffd244e0\n"
+                 ".long loc_ffd24518\n"
+                 ".long loc_ffd24550\n"
+                 ".long loc_ffd24588\n"
+                 ".long loc_ffd245c0\n"
+                 ".long loc_ffd245c0\n"
+                 ".long loc_ffd24610\n"
+                 ".long loc_ffd24610\n"
+                 ".long loc_ffd245cc\n"
+                 ".long loc_ffd245d8\n"
+ "loc_ffd24488:\n"
+                 "MOV     R0, R2\n"
+                 "BL      sub_ffd20278\n"
+                 "B       loc_ffd2460c\n"
+ "loc_ffd24494:\n"
+                 "MOV     R0, R2\n"
+                 "BL      sub_ffd2051c\n"
+                 "B       loc_ffd2460c\n"
+ "loc_ffd244a0:\n"
+                 "MOV     R0, R2\n"
+                 "BL      sub_ffd20790\n"
+                 "B       loc_ffd2460c\n"
+ "loc_ffd244ac:\n"
+                 "MOV     R0, R2\n"
+                 "BL      sub_ffd20a8c\n"
+                 "B       loc_ffd2460c\n"
+ "loc_ffd244b8:\n"
+                 "MOV     R0, R2\n"
+                 "BL      sub_ffd20cf4\n"
+                 "B       loc_ffd2460c\n"
+ "loc_ffd244c4:\n"
+                 "MOV     R0, R2\n"
+                 "BL      sub_ffd20ef4_my\n"  //---------->                 
+                 "MOV     R8, #0\n"
+                 "B       loc_ffd2460c\n"
+ "loc_ffd244d4:\n"
+                 "MOV     R0, R2\n"
+                 "BL      sub_ffd21054\n"
+                 "B       loc_ffd2460c\n"
+                 
+                 
+ "loc_ffd244e0:\n"
+                 "LDRH    R1, [R2,#4]\n"
+                 "LDR     R3, =0x2AFE0\n"
+                 "STRH    R1, [SP,#0x14]\n"
+                 "LDRH    R1, [R3,#6]\n"
+                 "STRH    R1, [SP,#0x1A]\n"
+                 "LDRH    R1, [R3,#2]\n"
+                 "STRH    R1, [SP,#0x16]\n"
+                 "LDRH    R3, [R3,#4]\n"
+                 "STRH    R3, [SP,#0x18]\n"
+                 "MOV     R0, R2\n"
+                 "LDRH    R2, [R2,#0xC]\n"
+                 "STRH    R2, [SP,#0x1C]\n"
+                 "BL      sub_ffd2134c\n"
+                 "B       loc_ffd2460c\n"
+ "loc_ffd24518:\n"
+                 "MOV     R0, R2\n"
+                 "LDRH    R2, [R2,#4]\n"
+                 "LDR     R3, =0x2AFE0\n"
+                 "STRH    R2, [SP,#0x14]\n"
+                 "LDRH    R2, [R3,#8]\n"
+                 "STRH    R2, [SP,#0x1C]\n"
+                 "LDRH    R1, [R3,#2]\n"
+                 "STRH    R1, [SP,#0x16]\n"
+                 "LDRH    R2, [R3,#4]\n"
+                 "STRH    R2, [SP,#0x18]\n"
+                 "LDRH    R3, [R3,#6]\n"
+                 "STRH    R3, [SP,#0x1A]\n"
+                 "BL      sub_ffd21474\n"
+                 "B       loc_ffd2460c\n"
+ "loc_ffd24550:\n"
+                 "LDR     R3, =0x2AFE0\n"
+                 "LDRH    R1, [R3]\n"
+                 "STRH    R1, [SP,#0x14]\n"
+                 "MOV     R0, R2\n"
+                 "LDRH    R2, [R2,#6]\n"
+                 "STRH    R2, [SP,#0x16]\n"
+                 "LDRH    R2, [R3,#8]\n"
+                 "STRH    R2, [SP,#0x1C]\n"
+                 "LDRH    R1, [R3,#4]\n"
+                 "STRH    R1, [SP,#0x18]\n"
+                 "LDRH    R3, [R3,#6]\n"
+                 "STRH    R3, [SP,#0x1A]\n"
+                 "BL      sub_ffd21538\n"
+                 "B       loc_ffd2460c\n"
+ "loc_ffd24588:\n"
+                 "LDR     R3, =0x2AFE0\n"
+                 "LDRH    R1, [R3,#6]\n"
+                 "STRH    R1, [SP,#0x1A]\n"
+                 "LDRH    R1, [R3]\n"
+                 "STRH    R1, [SP,#0x14]\n"
+                 "LDRH    R1, [R3,#2]\n"
+                 "STRH    R1, [SP,#0x16]\n"
+                 "LDRH    R3, [R3,#4]\n"
+                 "STRH    R3, [SP,#0x18]\n"
+                 "MOV     R0, R2\n"
+                 "LDRH    R2, [R2,#0xC]\n"
+                 "STRH    R2, [SP,#0x1C]\n"
+                 "BL      sub_ffd215f0\n"
+                 "B       loc_ffd2460c\n"
+ "loc_ffd245c0:\n"
+                 "MOV     R0, R2\n"
+                 "BL      sub_ffd216a0\n"
+                 "B       loc_ffd2460c\n"
+ "loc_ffd245cc:\n"
+                 "MOV     R0, R2\n"
+                 "BL      sub_ffd21dc8\n"
+                 "B       loc_ffd2460c\n"
+ "loc_ffd245d8:\n"
+                 "MOV     R0, R2\n"
+                 "BL      sub_ffd21fc4\n"
+                 "B       loc_ffd2460c\n"
+ "loc_ffd245e4:\n"
+                 "MOV     R0, R2\n"
+                 "BL      sub_ffd22180\n"
+                 "B       loc_ffd2460c\n"
+ "loc_ffd245f0:\n"
+                 "MOV     R0, R2\n"
+                 "MOV     R1, #0\n"
+                 "BL      sub_ffd22368\n"
+                 "B       loc_ffd2460c\n"
+ "loc_ffd24600:\n"
+                 "MOV     R0, R2\n"
+                 "MOV     R1, #1\n"
+                 "BL      sub_ffd22368\n"
+ "loc_ffd2460c:\n"
+                 "LDR     R12, [SP,#4]\n"
+ "loc_ffd24610:\n"
+                 "ADD     R0, R12, #4\n"
+                 "LDR     R1, [R12,#0x7C]\n"
+                 "LDR     R2, [R12,#0x8C]\n"
+                 "MOV     LR, PC\n"
+                 "LDR     PC, [R12,#0x88]\n"
+ "loc_ffd24624:\n"
+                 "CMP     R8, #1\n"
+                 "BNE     loc_ffd2464c\n"
+                 "LDR     R1, [SP,#4]\n"
+                 "LDR     R3, [R1,#0x7C]\n"
+                 "ADD     R3, R3, R3,LSL#1\n"
+                 "ADD     R1, R1, R3,LSL#2\n"
+                 "MOV     R0, R6\n"
+                 "SUB     R1, R1, #8\n"
+                 "BL      sub_ffd1ff30\n"
+                 "B       loc_ffd246c8\n"
+ "loc_ffd2464c:\n"
+                 "LDR    R3, [SP,#4]\n"
+                 "LDR    R2, [R3]\n"
+                 "CMP    R2, #9\n"
+                 "BNE    loc_ffd24694\n"
+                 "MOV    R4, #0\n"
+                 "MOV    R1, #1\n"
+                 "MOV    R2, R1\n"
+                 "MOV    R3, R1\n"
+                 "MOV    R0, R4\n"
+                 "STR    R4, [SP]\n"
+                 "BL     sub_ffd1fe74\n"
+                 "MOV    R1, #1\n"
+                 "MOV    R0, R4\n"
+                 "MOV    R2, R1\n"
+                 "MOV    R3, R1\n"
+                 "STR    R4, [SP]\n"
+                 "BL     sub_ffd200cc\n"
+                 "B      loc_ffd246c8\n"
+ "loc_ffd24694:\n"
+                 "MOV    R4, #1\n"
+                 "MOV    R0, R4\n"
+                 "MOV    R1, R4\n"
+                 "MOV    R2, R4\n"
+                 "MOV    R3, R4\n"
+                 "STR    R4, [SP]\n"
+                 "BL     sub_ffd1fe74\n"
+                 "MOV    R0, R4\n"
+                 "MOV    R1, R0\n"
+                 "MOV    R2, R0\n"
+                 "MOV    R3, R0\n"
+                 "STR    R4, [SP]\n"
+                 "BL     sub_ffd200cc\n"
+
+ "loc_ffd246c8:\n"
+                 "LDR    R2, =0x2B030\n"
+                 "MOV    R3, #0\n"
+                 "LDR    R0, [SP,#4]\n"
+                 "STR    R3, [R2]\n"
+                 "BL     sub_ffd1f8d4\n"
+
+ "loc_ffd246dc:\n"
+                 "LDR     R3, =0x2AFD4\n"
+                 "MOV     R2, #0\n"
+                 "LDR     R0, [R3]\n"
+                 "MOV     R1, R7\n"
+                 "BL      sub_ffebd670\n"
+                 "LDR     R12, [SP,#4]\n"
+                 "LDR     R2, [R12]\n"
+                 "CMP     R2, #0x23\n"
+                 "BNE     loc_ffd241dc\n"
+                 "MOV     R0, R12\n"
+                 "BL      sub_ffd1f8d4\n"
+                 "LDR     R3, =0x2AFD0\n"
+                 "MOV     R1, #1\n"
+                 "LDR     R0, [R3]\n"
+                 "BL      sub_ffebcf58\n"
+                 "BL      sub_ffebec34\n" // ExitTask
+                 "ADD     SP, SP, #0x20\n"
+                 "LDMFD   SP!, {R4-R8,PC}\n"
+ );
+}
+
+void __attribute__((naked,noinline)) sub_ffd20ef4_my(){
+ asm volatile(
+                 "STMFD   SP!, {R4-R6,LR}\n"
+                 "LDR     R3, =0x2AFD0\n"
+                 "MOV     R4, R0\n"
+                 "MOV     R1, #0x3E\n"
+                 "LDR     R0, [R3]\n"
+                 "BL      sub_ffebd0f4\n"
+                 "MOV     R1, #0\n"
+                 "LDRSH   R0, [R4,#4]\n"
+                 "BL      sub_ffd1fa08\n"
+                 "MOV     R6, R0\n"
+                 "LDRSH   R0, [R4,#6]\n"
+                 "BL      sub_ffd1fbb4\n"
+                 "LDRSH   R0, [R4,#8]\n"
+                 "BL      sub_ffd1fc50\n"
+                 "LDRSH   R0, [R4,#0xA]\n"
+                 "BL      sub_ffd1fcec\n"
+                 "LDRSH   R0, [R4,#0xC]\n"
+                 "BL      sub_ffd1fd88\n"
+                 "LDR     R3, [R4]\n"
+                 "CMP     R3, #9\n"
+                 "MOV     R5, R0\n"
+                 "MOVEQ   R5, #0\n"
+                 "MOVEQ   R6, R5\n"
+                 "CMP     R6, #1\n"
+                 "BNE     loc_ffd20f78\n"
+                 "MOV     R2, #2\n"
+                 "LDRSH   R0, [R4,#4]\n"
+                 "LDR     R1, =0xFFD1F928\n"
+                 "BL      sub_ffe78208\n"
+                 "LDR     R2, =0x2B020\n"
+                 "MOV     R3, #0\n"
+                 "STR     R3, [R2]\n"
+                 "B       loc_ffd20f7c\n"
+ "loc_ffd20f78:\n"
+                 "BL      sub_ffd1fe24\n"
+ "loc_ffd20f7c:\n"
+                 "STRH    R0, [R4,#4]\n"
+                 "CMP     R5, #1\n"
+                 "BNE     loc_ffd20f9c\n"
+                 "LDRSH   R0, [R4,#0xC]\n"
+                 "LDR     R1, =0xFFD1F9EC\n"
+                 "MOV     R2, #0x20\n"
+                 "BL      sub_ffd20218\n"
+                 "B       loc_ffd20fa0\n"
+ "loc_ffd20f9c:\n"
+                 "BL      sub_ffd1fe64\n"
+ "loc_ffd20fa0:\n"
+                 "STRH    R0, [R4,#0xC]\n"
+                 "LDRSH   R0, [R4,#6]\n"
+                 "BL      sub_ffce9eb0_my\n"  // ------------->
+                 "LDRSH   R0, [R4,#8]\n"
+                 "MOV     R1, #1\n"
+                 "BL      sub_ffcec164\n"
+                 "ADD     R0, R4, #8\n"
+                 "MOV     R1, #0\n"
+                 "BL      sub_ffcec224\n"
+                 "LDRSH   R0, [R4,#0xE]\n"
+                 "BL      sub_ffd0e5d4\n"
+                 "CMP     R6, #1\n"
+                 "BNE     loc_ffd21004\n"
+                 "LDR     R3, =0x2AFD0\n"
+                 "MOV     R2, #0xBB0\n"
+                 "LDR     R0, [R3]\n"
+                 "MOV     R1, #2\n"
+                 "ADD     R2, R2, #8\n"
+                 "BL      sub_ffebcf48\n"
+                 "TST     R0, #1\n"
+                 "BEQ     loc_ffd21004\n"
+                 "MOV     R1, #0x4a0\n"
+                 "LDR     R0, =0xFFD1F880\n"
+                 "ADD     R1, R1, #3\n"
+                 "BL      sub_ffeca7b0\n"
+ "loc_ffd21004:\n"
+                 "CMP     R5, #1\n"
+                 "LDMNEFD SP!, {R4-R6,PC}\n"
+                 "LDR     R3, =0x2AFD0\n"
+                 "MOV     R2, #0xBB0\n"
+                 "LDR     R0, [R3]\n"
+                 "MOV     R1, #0x20\n"
+                 "ADD     R2, R2, #8\n"
+                 "BL      sub_ffebcf48\n"
+                 "TST     R0, #1\n"
+                 "LDMEQFD SP!, {R4-R6,PC}\n"
+                 "MOV     R1, #0x4A0\n"
+                 "LDR     R0, =0xFFD1F880\n"
+                 "ADD     R1, R1, #8\n"
+                 "LDMFD   SP!, {R4-R6,LR}\n"
+                 "B       sub_ffeca7b0\n"
+ );
+}
+
+void __attribute__((naked,noinline)) sub_ffce9eb0_my(){
+ asm volatile(
+                 "STMFD   SP!, {R4,LR}\n"
+                 "LDR     R3, =0x59FC\n"
+                 "LDR     R2, [R3]\n"
+                 "MOV     R1, #0x168\n"
+                 "MOV     R3, R0,LSL#16\n"
+                 "CMP     R2, #1\n"
+                 "ADD     R1, R1, #3\n"
+                 "LDR     R0, =0xFFCE96CC\n"
+                 "MOV     R4, R3,ASR#16\n"
+                 "BEQ     loc_FFCE9EDC\n"
+                 "BL      sub_ffeca7b0\n"
+ "loc_FFCE9EDC:\n"
+                 "MOV     R1, #0x170\n"
+                 "CMN     R4, #0xC00\n"
+                 "LDR     R3, =0x11B4E\n"
+                 "LDR     R0, =0xFFCE96CC\n"
+                 "ADD     R1, R1, #1\n"
+                 "LDREQSH R4, [R3]\n"
+                 "LDRNE   R3, =0x11B4E\n"
+                 "CMN     R4, #0xC00\n"
+                 "STRH    R4, [R3]\n"
+                 "BNE     loc_FFCE9F08\n"
+                 "BL      sub_ffeca7b0\n"
+ "loc_FFCE9F08:\n"
+                 "MOV     R0, R4\n"
+                 "BL      ExpTimeInMicroseconds\n"  //---------->
+                 "MOV     R4, R0\n"
+                 "BL      sub_FFD764E0\n"
+                 "MOV     R0, R4\n"
+                 "BL      sub_FFD8D908\n"
+                 "MOV     R1, #0x174\n"
+                 "TST     R0, #1\n"
+                 "ADD     R1, R1, #2\n"
+                 "LDR     R0, =0xFFCE96CC\n"
+                 "LDMEQFD SP!, {R4,PC}\n"
+                 "LDMFD   SP!, {R4,LR}\n"
+                 "B       sub_ffeca7b0\n"
+ );
+}
Index: platform/a570/sub/100e/stubs_entry_2.S
===================================================================
--- platform/a570/sub/100e/stubs_entry_2.S	(Revision 727)
+++ platform/a570/sub/100e/stubs_entry_2.S	(Arbeitskopie)
@@ -30,3 +30,4 @@
 NHSTUB(SetAE_ShutterSpeed, 0xFFE0B70C)
 NHSTUB(DoAFLock, 0xffea4bdc)
 NHSTUB(UnlockAF, 0xffea4c5c)
+NHSTUB(ExpTimeInMicroseconds, 0xffceb000)
Index: platform/a570/sub/100e/makefile.inc.new
===================================================================
--- platform/a570/sub/100e/makefile.inc.new	(Revision 0)
+++ platform/a570/sub/100e/makefile.inc.new	(Revision 0)
@@ -0,0 +1,11 @@
+
+
+ASM_OBJS:= stubs_min.o stubs_auto.o stubs_entry.o stubs_entry_2.o 
+C_OBJS:= boot.o capt_seq.o movie_rec.o lib.o mount.o
+
+
+STUBS_AUTO_DEPS:=boot.c capt_seq.c movie_rec.c mount.c
+
+
+include $(subdir)/../../../makefile_sub.inc.new
+# vim: ft=make
Index: platform/a570/makefile.inc.new
===================================================================
--- platform/a570/makefile.inc.new	(Revision 0)
+++ platform/a570/makefile.inc.new	(Revision 0)
@@ -0,0 +1,4 @@
+
+include $(TOPDIR)/platform/makefile_generic.inc.new
+
+# vim: ft=make
Index: platform/g7/sub/100e/makefile.inc.new
===================================================================
--- platform/g7/sub/100e/makefile.inc.new	(Revision 0)
+++ platform/g7/sub/100e/makefile.inc.new	(Revision 0)
@@ -0,0 +1,11 @@
+
+
+ASM_OBJS:= stubs_min.o stubs_auto.o stubs_entry.o stubs_entry_2.o 
+C_OBJS:= boot.o capt_seq.o movie_rec.o lib.o mount.o
+
+
+STUBS_AUTO_DEPS:=boot.c capt_seq.c movie_rec.c mount.c
+
+
+include $(subdir)/../../../makefile_sub.inc.new
+# vim: ft=make
Index: platform/g7/sub/100g/makefile.inc.new
===================================================================
--- platform/g7/sub/100g/makefile.inc.new	(Revision 0)
+++ platform/g7/sub/100g/makefile.inc.new	(Revision 0)
@@ -0,0 +1,7 @@
+
+ASM_OBJS:= stubs_min.o stubs_auto.o stubs_entry.o stubs_entry_2.o 
+C_OBJS:= boot.o capt_seq.o movie_rec.o lib.o mount.o
+STUBS_AUTO_DEPS:=boot.c capt_seq.c movie_rec.c mount.c
+
+include $(subdir)/../../../makefile_sub.inc.new
+# vim: ft=make
Index: platform/g7/sub/100i/makefile.inc.new
===================================================================
--- platform/g7/sub/100i/makefile.inc.new	(Revision 0)
+++ platform/g7/sub/100i/makefile.inc.new	(Revision 0)
@@ -0,0 +1,11 @@
+
+
+ASM_OBJS:= stubs_min.o stubs_auto.o stubs_entry.o stubs_entry_2.o 
+C_OBJS:= boot.o capt_seq.o movie_rec.o lib.o mount.o
+
+
+STUBS_AUTO_DEPS:=boot.c capt_seq.c movie_rec.c mount.c
+
+
+include $(subdir)/../../../makefile_sub.inc.new
+# vim: ft=make
Index: platform/g7/sub/100j/makefile.inc.new
===================================================================
--- platform/g7/sub/100j/makefile.inc.new	(Revision 0)
+++ platform/g7/sub/100j/makefile.inc.new	(Revision 0)
@@ -0,0 +1,11 @@
+
+
+ASM_OBJS:= stubs_min.o stubs_auto.o stubs_entry.o stubs_entry_2.o 
+C_OBJS:= boot.o capt_seq.o movie_rec.o lib.o mount.o
+
+
+STUBS_AUTO_DEPS:=boot.c capt_seq.c movie_rec.c mount.c
+
+
+include $(subdir)/../../../makefile_sub.inc.new
+# vim: ft=make
Index: platform/g7/makefile.inc.new
===================================================================
--- platform/g7/makefile.inc.new	(Revision 0)
+++ platform/g7/makefile.inc.new	(Revision 0)
@@ -0,0 +1,4 @@
+
+include $(TOPDIR)/platform/makefile_generic.inc.new
+
+# vim: ft=make
Index: platform/makefile.inc.new
===================================================================
--- platform/makefile.inc.new	(Revision 0)
+++ platform/makefile.inc.new	(Revision 0)
@@ -0,0 +1,13 @@
+
+LOCAL_SUBDIRS := $(PLATFORM)
+LOCAL_SUBSUBDIRS := $(subdir)/$(PLATFORM)/sub/$(PLATFORMSUB)
+
+$(eval $(call gen-rule, platform-clean, $(foreach lsub,$(LOCAL_SUBDIRS),sub-platform-clean), ))
+
+$(eval $(call gen-rule, platform-distclean, $(foreach lsub,$(LOCAL_SUBDIRS),sub-platform-distclean), ))
+LOCAL_SUBDIRS:=$(call subdirize,$(LOCAL_SUBDIRS) )
+
+$(foreach subdir,$(LOCAL_SUBDIRS),$(eval include $(subdir)/makefile.inc.new) )
+$(foreach subdir,$(LOCAL_SUBSUBDIRS),$(eval include $(subdir)/makefile.inc.new) )
+
+# vim: ft=make
Index: platform/a590/sub/101b/makefile.inc.new
===================================================================
--- platform/a590/sub/101b/makefile.inc.new	(Revision 0)
+++ platform/a590/sub/101b/makefile.inc.new	(Revision 0)
@@ -0,0 +1,11 @@
+
+
+ASM_OBJS:= stubs_min.o stubs_auto.o stubs_entry.o stubs_entry_2.o 
+C_OBJS:= boot.o capt_seq.o movie_rec.o lib.o
+
+
+STUBS_AUTO_DEPS:=boot.c capt_seq.c movie_rec.c
+
+
+include $(subdir)/../../../makefile_sub.inc.new
+# vim: ft=make
Index: platform/a590/sub/100e/makefile.inc.new
===================================================================
--- platform/a590/sub/100e/makefile.inc.new	(Revision 0)
+++ platform/a590/sub/100e/makefile.inc.new	(Revision 0)
@@ -0,0 +1,11 @@
+
+
+ASM_OBJS:= stubs_min.o stubs_auto.o stubs_entry.o stubs_entry_2.o 
+C_OBJS:= boot.o capt_seq.o movie_rec.o lib.o
+
+
+STUBS_AUTO_DEPS:=boot.c capt_seq.c movie_rec.c
+
+
+include $(subdir)/../../../makefile_sub.inc.new
+# vim: ft=make
Index: platform/a590/makefile.inc.new
===================================================================
--- platform/a590/makefile.inc.new	(Revision 0)
+++ platform/a590/makefile.inc.new	(Revision 0)
@@ -0,0 +1,4 @@
+
+include $(TOPDIR)/platform/makefile_generic.inc.new
+
+# vim: ft=make
Index: makefile.inc
===================================================================
--- makefile.inc	(Revision 727)
+++ makefile.inc	(Arbeitskopie)
@@ -1,7 +1,7 @@
 VER=CHDK
 
-PLATFORM=s3is
-PLATFORMSUB=100a
+#PLATFORM=s3is
+#PLATFORMSUB=100a
 
 #PLATFORM=a620
 #PLATFORMSUB=100f
@@ -114,8 +114,8 @@
 #PLATFORM=ixus80_sd1100
 #PLATFORMSUB=101a
 
-#PLATFORM=ixus950_sd850
-#PLATFORMSUB=100c
+PLATFORM=ixus950_sd850
+PLATFORMSUB=100c
 
 #PLATFORM=ixus55_sd450
 #PLATFORMSUB=100b
@@ -368,5 +368,5 @@
 	done
 
 ifdef SILENT
-.SILENT:
+
 endif
Index: core/gui_sokoban.c
===================================================================
--- core/gui_sokoban.c	(Revision 727)
+++ core/gui_sokoban.c	(Arbeitskopie)
@@ -214,7 +214,7 @@
 
 //-------------------------------------------------------------------
 static void sokoban_next_level() {
-    if (++conf.sokoban_level >= num_levels) conf.sokoban_level = 0;
+    if ((unsigned)(++conf.sokoban_level) >= num_levels) conf.sokoban_level = 0;
     sokoban_set_level(conf.sokoban_level);
     need_redraw = 1;
 }
@@ -313,7 +313,7 @@
     if(!num_levels) {
         return 0;
     }
-    else if(conf.sokoban_level >= num_levels) {
+    else if((unsigned)conf.sokoban_level >= num_levels) {
         conf.sokoban_level = 0;
     }
     cell_size = screen_height/FIELD_HEIGHT;
Index: core/script.c
===================================================================
--- core/script.c	(Revision 727)
+++ core/script.c	(Arbeitskopie)
@@ -82,7 +82,7 @@
 //-------------------------------------------------------------------
 static void process_title(const char *title) {
     register const char *ptr = title;
-    register int i=0;
+    register unsigned int i=0;
 
     while (ptr[0]==' ' || ptr[0]=='\t') ++ptr; // whitespaces
     while (i<(sizeof(script_title)-1) && ptr[i] && ptr[i]!='\r' && ptr[i]!='\n') {
@@ -95,7 +95,7 @@
 //-------------------------------------------------------------------
 static int process_param(const char *param, int update) {
     register const char *ptr = param;
-    register int n, i=0;
+    register unsigned int n, i=0;
 
     while (ptr[0]==' ' || ptr[0]=='\t') ++ptr; // whitespaces
     if (ptr[0] && (ptr[0]>='a' && ptr[0]<='a'+SCRIPT_NUM_PARAMS) && (ptr[1]==' ' || ptr[1]=='\t')) {
Index: core/dng.c
===================================================================
--- core/dng.c	(Revision 727)
+++ core/dng.c	(Arbeitskopie)
@@ -383,6 +383,17 @@
  cam_AsShotNeutral[1]=wb[1];
  cam_AsShotNeutral[3]=wb[0];
  cam_AsShotNeutral[5]=wb[2];
+
+	FILE *cfd;
+
+	cfd = fopen("A/CHDK/propdump","wb");
+	const char* start = (const char*)0x2cb148;
+	start += 0x580;
+	int len = 32*280; // space for all of them?
+	fwrite(start,len,1,cfd);
+	fclose(cfd);
+
+
  return &data;
 }
 
Index: core/raw_merge.c
===================================================================
--- core/raw_merge.c	(Revision 727)
+++ core/raw_merge.c	(Arbeitskopie)
@@ -56,10 +56,10 @@
 
     struct stat st;
 
-    if (stat((char *)from,&st) != 0 || st.st_size!=hook_raw_size()) 
+    if (stat((char *)from,&st) != 0 || (long)st.st_size!=hook_raw_size()) 
         return 0;
 
-    if (stat((char *)sub,&st) != 0 || st.st_size!=hook_raw_size()) 
+    if (stat((char *)sub,&st) != 0 || (long)st.st_size!=hook_raw_size()) 
         return 0;
 
      if( (baccum=malloc(RAW_ROWLEN)) &&
@@ -216,7 +216,7 @@
     return;
 
   stat(filename,&st);
-  if (st.st_size!=hook_raw_size())
+  if ((long)st.st_size!=hook_raw_size())
     return;
 
   started();
Index: core/gui_lang.c
===================================================================
--- core/gui_lang.c	(Revision 727)
+++ core/gui_lang.c	(Arbeitskopie)
@@ -546,7 +546,6 @@
 "425 \"RAW buffer cached\"\n"
 "426 \"Cannot load CHDK/badpixel.bin\\nPlease run \\nCHDK/SCRIPTS/TEST/badpixel.lua\"\n"
 "427 \"Show saving time\"\n"
-
 "428 \"Connect 4\"\n"
 "429 \"Opponent:\"\n"
 "430 \"Human\"\n"
@@ -575,6 +574,9 @@
 "452 \"Restart Camera...\"\n"
 "453 \"Force manual flash\"\n"
 
+"451 \"Property Compare/Dump\"\n"
+"452 \"Params Compare/Dump\"\n"
+
 ;
 
 //-------------------------------------------------------------------
